using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

using Android.App;
using Android.Content;
using Android.OS;
using Android.Runtime;
using Android.Views;
using Android.Widget;
using ChartSample;
using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.Droid;
using Xamarin.Forms;
using Xamarin.Forms.Platform.Android;
using NativeChart = Com.Syncfusion.Widget.Chart.SfChart;
using System.Collections.ObjectModel;

[assembly: ExportRenderer(typeof(CustomChart), typeof(ChartSample.Droid.CustomRenderer))]

namespace ChartSample.Droid
{
    public class CustomRenderer:SfChartRenderer
    {
		CustomChart chart;

        public CustomRenderer()
        {

        }

       protected override void OnElementChanged(ElementChangedEventArgs<SfChart> e)
        {
            base.OnElementChanged(e);
			chart = e.NewElement as CustomChart;

            if (Control != null)
            {
                Control.Touch -= Control_Touch;
				Control.Touch += Control_Touch;
            }
        }
		
        void Control_Touch(object sender, Android.Views.View.TouchEventArgs e)
		{
			var chart = sender as NativeChart;
		
			var pos = chart.PointToValue (chart.PrimaryAxis, new Android.Graphics.PointF (e.Event.GetX () - chart.SeriesClipRect.Left,
				            e.Event.GetY ()));

			pos = (float)Math.Round (pos);

			var series = Element.Series [0];

			var data = series.ItemsSource as ObservableCollection<ChartDataPoint>;
		
			this.chart.RaiseTouchEvent (chart, 
				new ChartEventArgs (pos < data.Count && pos >= 0 ? data[(int)pos] : data[0],
					series));
		}
	}
}