﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using ChartSample;
using Microsoft.Phone.Reactive;
using Syncfusion.SfChart.XForms;
using Syncfusion.SfChart.XForms.WinPhone;
using Syncfusion.UI.Xaml.Charts;
using Xamarin.Forms;
using Xamarin.Forms.Platform.WinPhone;
[assembly: ExportRenderer(typeof(CustomChart), typeof( ChartSample.WinPhone.CustomRenderer))]

namespace ChartSample.WinPhone
{
    public class CustomRenderer : SfChartRenderer
    {
        private CustomChart chart;

        protected override void OnElementChanged(ElementChangedEventArgs<Syncfusion.SfChart.XForms.SfChart> e)
        {
            base.OnElementChanged(e);
            if (Control == null) return;
            Control.Behaviors.Add(new ChartSelectionBehavior());
            if (Control.Series[0] is ISegmentSelectable)
                (Control.Series[0] as ISegmentSelectable).SegmentSelectionBrush = Control.Series[0].Interior;
            Control.SelectionChanged += Control_SelectionChanged;
            chart = e.NewElement as CustomChart;
        }

        private void Control_SelectionChanged(object sender, ChartSelectionChangedEventArgs e)
        {
            var dataPoint = Control.Series[0].ItemsSource as ObservableCollection<ChartDataPoint>;
            chart.RaiseTouchEvent(chart, new ChartEventArgs(dataPoint[e.SelectedIndex], Element.Series[0]));
        }
    }
}
