﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using ChartSample;
using Syncfusion.SfChart.XForms;
using Xamarin.Forms;
using Syncfusion.SfChart.XForms.iOS.Renderers;
using MonoTouch.UIKit;
using System.Drawing;
using System.Collections.ObjectModel;

[assembly: ExportRenderer(typeof(CustomChart), typeof(Syncfusion.SfChart.XForms.iOS.CustomRenderer))]
namespace Syncfusion.SfChart.XForms.iOS
{
    public class CustomRenderer:SfChartRenderer
    {
        private CustomChart chart = null;
        public CustomRenderer()
        {
           
        }

		protected override void OnElementChanged (Xamarin.Forms.Platform.iOS.ElementChangedEventArgs<SfChart> e)
		{
			base.OnElementChanged (e);
			chart = e.NewElement as CustomChart;
		}

		public override void TouchesBegan (MonoTouch.Foundation.NSSet touches, UIEvent evt)
		{
			base.TouchesMoved (touches, evt);
			UITouch touch=(UITouch)(evt.AllTouches.AnyObject);
			System.Drawing.PointF currentPoint = (PointF)(touch.LocationInView(this)) ;

			Syncfusion.SfChart.iOS.SFChart chart = Control as Syncfusion.SfChart.iOS.SFChart;

			ChartSeries series = Element.Series [0];

			ObservableCollection<ChartDataPoint> data = series.ItemsSource as ObservableCollection<ChartDataPoint>;
			float pos = PointToValue (currentPoint.X - chart.SeriesClipRect.Left, chart.SeriesClipRect.Width, data.Count);

			pos = (float)Math.Round(pos) - 1;
			this.chart.RaiseTouchEvent(chart,new ChartEventArgs(pos < data.Count && pos >= 0? data[(int)pos] : data[0],
				series));
		}

		private float PointToValue(float x, float width, int delta)
		{
			float coeff = x / width;
			return coeff * delta;
		}
	}
}