﻿using Syncfusion.SfChart.XForms;
using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace ChartSample
{
    public class SimpleSample:ContentPage
    {
		Label disp;

        public SimpleSample()
        {
			StackLayout stackLayout = new StackLayout ();
			stackLayout.Children.Add (GetChart ());

			disp = new Label ();
			disp.Text = "Display";

			stackLayout.Children.Add (disp);

			Content = stackLayout;         
        }
        
        private CustomChart GetChart()
		{
			var chart = new CustomChart ();

			chart.VerticalOptions = LayoutOptions.FillAndExpand;
			chart.HorizontalOptions = LayoutOptions.FillAndExpand;

			chart.PrimaryAxis = new CategoryAxis ();
			chart.SecondaryAxis = new NumericalAxis ();

			var pointsSeries = new ColumnSeries ();

			var precipitation = new ObservableCollection<ChartDataPoint>();

			precipitation.Add(new ChartDataPoint("Jan", 3.03));
			precipitation.Add(new ChartDataPoint("Feb", 2.48));
			precipitation.Add(new ChartDataPoint("Mar", 3.23));
			precipitation.Add(new ChartDataPoint("Apr", 3.15));
			precipitation.Add(new ChartDataPoint("May", 4.13));
			precipitation.Add(new ChartDataPoint("Jun", 3.23));
			precipitation.Add(new ChartDataPoint("Jul", 4.13));
			precipitation.Add(new ChartDataPoint("Aug", 4.88));
			precipitation.Add(new ChartDataPoint("Sep", 3.82));
			precipitation.Add(new ChartDataPoint("Oct", 3.07));
			precipitation.Add(new ChartDataPoint("Nov", 2.83));
			precipitation.Add(new ChartDataPoint("Dec", 2.8));

			pointsSeries.ItemsSource = precipitation;
           
			chart.Series.Add (pointsSeries);
           
			chart.TouchEvent += chart_MoveEvent;

			return chart;
		}

        void chart_MoveEvent(object sender, ChartEventArgs args)
		{
			disp.Text = args.DataPoint.XValue.ToString();
		}
    }
}